bug-coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: snapshot in a few hours


From: Pádraig Brady
Subject: Re: snapshot in a few hours
Date: Fri, 4 Sep 2009 22:14:49 +0100
User-agent: Thunderbird 2.0.0.6 (X11/20071008)

Jim Meyering wrote:
> Pádraig Brady wrote:
>> Jim Meyering wrote:
>>> If anyone knows of bug-related fixes that aren't yet applied,
>>> please speak up.  I'm thinking of making a snapshot today,
>>> leading to a bug-fix release, coreutils-7.6, next week.
>> It would be nice to get Ondřej's fix for copy xattrs from readonly files.
>> I might be able to look at that in a couple of hours.
> 
> Thanks!
> 
>> There's also this one that popped up in our recent favorite: tail-2/wait
> 
> Right.  I suppose it'd be best to add some distcheck-time
> code to prevent this sort of regression: configure as if
> inotify were not available, and ensure the tail-related tests still pass.
> 
> Or maybe even add a hidden (three hyphen ---no-inotify, since we presume
> it'll be used only for testing) option to expose that behavior without
> the requirement to jump through build-time hoops.
> 
> What do you think?

I like the ---no-inotify option since the inotify support check is at
runtime anyway. How about the attached.

cheers,
Pádraig.
>From d168f1aabcff0f6bd79ce84864a76b052904baa5 Mon Sep 17 00:00:00 2001
From: =?utf-8?q?P=C3=A1draig=20Brady?= <address@hidden>
Date: Fri, 4 Sep 2009 21:41:30 +0100
Subject: [PATCH] tests: test old tail -f method even on systems with inotify

* src/tail.c (main): Add an undocumented ---no-inotify option
to allow disabling inotify.
* tests/tail-2/pid: Run test in both normal and "no_inotify" modes.
* tests/tail-2/tail-n0f: Likewise.
* tests/tail-2/wait: Likewise.
* tests/tail-2/append-only: Likewise.
---
 src/tail.c               |   29 ++++++++++++++-----
 tests/tail-2/append-only |    9 ++++--
 tests/tail-2/pid         |   46 ++++++++++++++++---------------
 tests/tail-2/tail-n0f    |   24 +++++++++-------
 tests/tail-2/wait        |   67 ++++++++++++++++++++++++---------------------
 5 files changed, 100 insertions(+), 75 deletions(-)

diff --git a/src/tail.c b/src/tail.c
index f0dbf5d..26e0d78 100644
--- a/src/tail.c
+++ b/src/tail.c
@@ -201,6 +201,10 @@ static bool have_read_stdin;
    more expensive) code unconditionally. Intended solely for testing.  */
 static bool presume_input_pipe;
 
+/* If nonzero then don't use inotify even if available.
+   Intended solely for testing.  */
+static bool no_inotify;
+
 /* For long options that have no equivalent short option, use a
    non-character as a pseudo short option, starting with CHAR_MAX + 1.  */
 enum
@@ -209,7 +213,8 @@ enum
   MAX_UNCHANGED_STATS_OPTION,
   PID_OPTION,
   PRESUME_INPUT_PIPE_OPTION,
-  LONG_FOLLOW_OPTION
+  LONG_FOLLOW_OPTION,
+  NO_INOTIFY_OPTION
 };
 
 static struct option const long_options[] =
@@ -218,6 +223,7 @@ static struct option const long_options[] =
   {"follow", optional_argument, NULL, LONG_FOLLOW_OPTION},
   {"lines", required_argument, NULL, 'n'},
   {"max-unchanged-stats", required_argument, NULL, MAX_UNCHANGED_STATS_OPTION},
+  {"-no-inotify", no_argument, NULL, NO_INOTIFY_OPTION}, /* do not document */
   {"pid", required_argument, NULL, PID_OPTION},
   {"-presume-input-pipe", no_argument, NULL,
    PRESUME_INPUT_PIPE_OPTION}, /* do not document */
@@ -1794,6 +1800,10 @@ parse_options (int argc, char **argv,
             }
           break;
 
+        case NO_INOTIFY_OPTION:
+          no_inotify = true;
+          break;
+
         case PID_OPTION:
           {
             strtol_error s_err;
@@ -1972,15 +1982,18 @@ main (int argc, char **argv)
   if (forever)
     {
 #if HAVE_INOTIFY
-      int wd = inotify_init ();
-      if (wd < 0)
-        error (0, errno, _("inotify cannot be used, reverting to polling"));
-      else
+      if (!no_inotify)
         {
-          tail_forever_inotify (wd, F, n_files, sleep_interval);
+          int wd = inotify_init ();
+          if (wd < 0)
+            error (0, errno, _("inotify cannot be used, reverting to 
polling"));
+          else
+            {
+              tail_forever_inotify (wd, F, n_files, sleep_interval);
 
-          /* The only way the above returns is upon failure.  */
-          exit (EXIT_FAILURE);
+              /* The only way the above returns is upon failure.  */
+              exit (EXIT_FAILURE);
+            }
         }
 #endif
       tail_forever (F, n_files, sleep_interval);
diff --git a/tests/tail-2/append-only b/tests/tail-2/append-only
index 0b4a959..fa59ea0 100755
--- a/tests/tail-2/append-only
+++ b/tests/tail-2/append-only
@@ -37,9 +37,12 @@ fi
 
 fail=0
 
-sleep 1 &
-pid=$!
-tail --pid=$pid -f f || fail=1
+for inotify in "---no-inotify" ""; do
+  sleep 1 &
+  pid=$!
+  tail --pid=$pid -f $inotify f || fail=1
+done
+
 chattr -a f 2>/dev/null
 
 Exit $fail
diff --git a/tests/tail-2/pid b/tests/tail-2/pid
index a797666..ec50a1c 100755
--- a/tests/tail-2/pid
+++ b/tests/tail-2/pid
@@ -22,32 +22,34 @@ if test "$VERBOSE" = yes; then
 fi
 
 . $srcdir/test-lib.sh
+getlimits_
 
 touch here || framework_failure
 
 fail=0
 
-# Use tail itself to create a background process to monitor.
-tail -f here &
-bg_pid=$!
-
-# Ensure that tail --pid=PID does not exit when PID is alive.
-timeout 1 tail -s.1 -f here --pid=$bg_pid
-test $? = 124 || fail=1
-
-# Cleanup background process
-kill $bg_pid
-
-# Ensure that tail --pid=PID exits successfully when PID is dead.
-# Use an unlikely-to-be-live PID
-getlimits_
-timeout 1 tail -s.1 --pid=$PID_T_MAX -f /dev/null
-ret=$?
-test $ret = 124 && skip_test_ "pid $PID_T_MAX present"
-test $ret = 0 || fail=1
-
-# Ensure fractional sleep parameter is honored with --pid
-timeout 1 tail -s.1 -f /dev/null --pid=$PID_T_MAX
-test $? = 124 && fail=1
+for inotify in "---no-inotify" ""; do
+  # Use tail itself to create a background process to monitor.
+  tail -f $inotify here &
+  bg_pid=$!
+
+  # Ensure that tail --pid=PID does not exit when PID is alive.
+  timeout 1 tail -s.1 -f $inotify here --pid=$bg_pid
+  test $? = 124 || fail=1
+
+  # Cleanup background process
+  kill $bg_pid
+
+  # Ensure that tail --pid=PID exits successfully when PID is dead.
+  # Use an unlikely-to-be-live PID
+  timeout 1 tail -s.1 --pid=$PID_T_MAX -f $inotify /dev/null
+  ret=$?
+  test $ret = 124 && skip_test_ "pid $PID_T_MAX present"
+  test $ret = 0 || fail=1
+
+  # Ensure fractional sleep parameter is honored with --pid
+  timeout 1 tail -s.1 -f $inotify /dev/null --pid=$PID_T_MAX
+  test $? = 124 && fail=1
+done
 
 Exit $fail
diff --git a/tests/tail-2/tail-n0f b/tests/tail-2/tail-n0f
index fce7ed1..fa65e87 100755
--- a/tests/tail-2/tail-n0f
+++ b/tests/tail-2/tail-n0f
@@ -35,17 +35,19 @@ echo anything > nonempty || framework_failure
 
 fail=0
 
-for file in empty nonempty; do
-  for c_or_n in c n; do
-    tail --sleep=4 -${c_or_n} 0 -f $file &
-    pid=$!
-    sleep .5
-    state=$(get_process_status_ $pid)
-    case $state in
-      S*) ;;
-      *) echo $0: process in unexpected state: $state 1>&2; fail=1 ;;
-    esac
-    kill $pid
+for inotify in "---no-inotify" ""; do
+  for file in empty nonempty; do
+    for c_or_n in c n; do
+      tail --sleep=4 -${c_or_n} 0 -f $inotify $file &
+      pid=$!
+      sleep .5
+      state=$(get_process_status_ $pid)
+      case $state in
+        S*) ;;
+        *) echo $0: process in unexpected state: $state 1>&2; fail=1 ;;
+      esac
+      kill $pid
+    done
   done
 done
 
diff --git a/tests/tail-2/wait b/tests/tail-2/wait
index a5f189f..70fb41e 100755
--- a/tests/tail-2/wait
+++ b/tests/tail-2/wait
@@ -30,43 +30,48 @@ touch k || framework_failure
 
 fail=0
 
-timeout 1 tail -s0.1 -f not_here
-test $? = 124 && fail=1
-
-if test ! -r unreadable; then # can't test this when root
-  timeout 1 tail -s0.1 -f unreadable
+for inotify in "---no-inotify" ""; do
+  timeout 1 tail -s0.1 -f $inotify not_here
   test $? = 124 && fail=1
-fi
 
-timeout 1 tail -s0.1 -f here 2>tail.err
-test $? = 124 || fail=1
+  if test ! -r unreadable; then # can't test this when root
+    timeout 1 tail -s0.1 -f $inotify unreadable
+    test $? = 124 && fail=1
+  fi
 
-# `tail -F' must wait in any case.
+  timeout 1 tail -s0.1 -f $inotify here 2>tail.err
+  test $? = 124 || fail=1
 
-timeout 1 tail -s0.1 -F here 2>>tail.err
-test $? = 124 || fail=1
+  # `tail -F' must wait in any case.
 
-if test ! -r unreadable; then # can't test this when root
-  timeout 1 tail -s0.1 -F unreadable
+  timeout 1 tail -s0.1 -F $inotify here 2>>tail.err
   test $? = 124 || fail=1
-fi
 
-timeout 1 tail -s0.1 -F not_here
-test $? = 124 || fail=1
-
-test -s tail.err && fail=1
-
-tail -s.1 --max-unchanged-stats=2 -F k > tail.out &
-pid=$!
-sleep .5
-mv k l
-sleep .5
-touch k
-mv k l
-sleep .5
-echo NO >> l
-sleep .5
-kill $pid
-test -s tail.out && fail=1
+  if test ! -r unreadable; then # can't test this when root
+    timeout 1 tail -s0.1 -F $inotify unreadable
+    test $? = 124 || fail=1
+  fi
+
+  timeout 1 tail -s0.1 -F $inotify not_here
+  test $? = 124 || fail=1
+
+
+  test -s tail.err && fail=1
+  :>tail.err
+
+
+  tail -s.1 --max-unchanged-stats=2 -F $inotify k > tail.out &
+  pid=$!
+  sleep .5
+  mv k l
+  sleep .5
+  touch k
+  mv k l
+  sleep .5
+  echo NO >> l
+  sleep .5
+  kill $pid
+  test -s tail.out && fail=1
+done
 
 Exit $fail
-- 
1.6.2.5


reply via email to

[Prev in Thread] Current Thread [Next in Thread]